commit-hurd
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[hurd] 04/07: Add an initscript for hurd-console


From: Samuel Thibault
Subject: [hurd] 04/07: Add an initscript for hurd-console
Date: Mon, 16 Sep 2013 07:41:31 +0000

This is an automated email from the git hooks/post-receive script.

sthibault pushed a commit to branch master
in repository hurd.

commit 338074efea9ef0a84906b529de143c1f79f8a8f9
Author: Samuel Thibault <address@hidden>
Date:   Mon Sep 16 00:46:36 2013 +0000

    Add an initscript for hurd-console
    
      * hurd.hurd-console.init: Add an initscript for hurd-console.
      * patches/hurd_console_startup.patch: Drop, this is no longer necessary 
with
        the initscript in place.
---
 debian/changelog                          |    3 +
 debian/hurd.hurd-console.init             |  125 +++++++++++++++++++++++++++++
 debian/patches/hurd_console_startup.patch |   32 --------
 3 files changed, 128 insertions(+), 32 deletions(-)

diff --git a/debian/changelog b/debian/changelog
index 89ad949..3d152b8 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -10,6 +10,9 @@ hurd (20130916-1) UNRELEASED; urgency=low
     mount-test-opts.patch, proxy-defpager.diff}: Refresh.
 
   [ Justus Winter ]
+  * hurd.hurd-console.init: Add an initscript for hurd-console.
+  * patches/hurd_console_startup.patch: Drop, this is no longer necessary with
+    the initscript in place.
   * control: Add build dependency on libdaemon
 
  -- Samuel Thibault <address@hidden>  Sat, 27 Jul 2013 22:37:17 +0000
diff --git a/debian/hurd.hurd-console.init b/debian/hurd.hurd-console.init
new file mode 100644
index 0000000..25050fc
--- /dev/null
+++ b/debian/hurd.hurd-console.init
@@ -0,0 +1,125 @@
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides:          hurd-console
+# Required-Start:    $all
+# Required-Stop:     
+# Default-Start:     1 2 3 4 5
+# Default-Stop:      0 6
+# Short-Description: Example initscript
+# Description:       This file should be used to construct scripts to be
+#                    placed in /etc/init.d.
+### END INIT INFO
+
+# Author: Justus Winter <address@hidden>
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/bin
+DESC="Hurd console multiplexer"
+NAME=console
+DAEMON=/bin/$NAME
+DAEMON_ARGS="--daemonize -d current_vcs -c /dev/vcs"
+PIDFILE=/var/run/$NAME.pid
+SCRIPTNAME=/etc/init.d/hurd-$NAME
+
+# Exit if the package is not installed
+[ -x "$DAEMON" ] || exit 0
+
+# Read configuration variable file if it is present
+[ -r /etc/default/hurd-$NAME ] && . /etc/default/hurd-$NAME
+
+# Augment the arguments.
+DAEMON_ARGS="${DAEMON_ARGS} ${DISPLAY} ${KBD} ${KBD_REPEAT} \
+             ${SPEAKER} ${MOUSE} ${MOUSE_REPEAT}"
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
+# and status_of_proc is working.
+. /lib/lsb/init-functions
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+       # Touch the first tty so that the Hurd console is certain to pick it
+       # and not some random other tty.
+       touch /dev/tty1
+
+       # Return
+       #   0 if daemon has been started
+       #   1 if daemon was already running
+       #   2 if daemon could not be started
+       start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON 
--test > /dev/null \
+               || return 1
+       start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
+               $DAEMON_ARGS \
+               || return 2
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+       # Return
+       #   0 if daemon has been stopped
+       #   1 if daemon was already stopped
+       #   2 if daemon could not be stopped
+       #   other if a failure occurred
+       start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile 
$PIDFILE --name $NAME
+       RETVAL="$?"
+
+       [ "$?" = 2 ] && return 2
+       # Many daemons don't delete their pidfiles when they exit.
+       #rm -f $PIDFILE
+       return "$RETVAL"
+}
+
+case "$1" in
+  start)
+       [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "hurd-$NAME"
+       do_start
+       case "$?" in
+               0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+               2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+       esac
+       ;;
+  stop)
+       [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "hurd-$NAME"
+       do_stop
+       case "$?" in
+               0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+               2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+       esac
+       ;;
+  status)
+       status_of_proc "$DAEMON" "hurd-$NAME" && exit 0 || exit $?
+       ;;
+  restart|force-reload)
+       log_daemon_msg "Restarting $DESC" "hurd-$NAME"
+       do_stop
+       case "$?" in
+         0|1)
+               do_start
+               case "$?" in
+                       0) log_end_msg 0 ;;
+                       1) log_end_msg 1 ;; # Old process is still running
+                       *) log_end_msg 1 ;; # Failed to start
+               esac
+               ;;
+         *)
+               # Failed to stop
+               log_end_msg 1
+               ;;
+       esac
+       ;;
+  *)
+       echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
+       exit 3
+       ;;
+esac
+
+:
diff --git a/debian/patches/hurd_console_startup.patch 
b/debian/patches/hurd_console_startup.patch
deleted file mode 100644
index 8e9301c..0000000
--- a/debian/patches/hurd_console_startup.patch
+++ /dev/null
@@ -1,32 +0,0 @@
-Automatically startup the hurd console when enabled.
----
- daemons/runsystem.sh |   14 ++++++++++++++
- 1 file changed, 14 insertions(+)
-
---- a/daemons/runsystem.sh
-+++ b/daemons/runsystem.sh
-@@ -127,10 +127,24 @@ while : ; do
-     trap "kill -$sig \${runttys_pid}" $sig
-   done
- 
-+  # Touch the first tty so that the Hurd console is certain to pick it
-+  # and not some random other tty.
-+  touch /dev/tty1
-+
-   # This program reads /etc/ttys and starts the programs it says to.
-   ${RUNTTYS} &
-   runttys_pid=$!
- 
-+  # Startup the Hurd console if configured.
-+  if [ -e /etc/default/hurd-console ]; then
-+    unset DISPLAY KBD KBD_REPEAT MOUSE MOUSE_REPEAT SPEAKER
-+    . /etc/default/hurd-console
-+  fi
-+  if [ "$ENABLE" = "true" ]; then
-+    console ${DISPLAY} ${KBD} ${KBD_REPEAT} \
-+            ${SPEAKER} ${MOUSE} ${MOUSE_REPEAT} -d current_vcs -c /dev/vcs
-+  fi
-+
-   # Wait for runttys to die, meanwhile handling trapped signals.
-   wait
- 

-- 
Alioth's /usr/local/bin/git-commit-notice on 
/srv/git.debian.org/git/pkg-hurd/hurd.git



reply via email to

[Prev in Thread] Current Thread [Next in Thread]